// eXgNX
// eXgΏ: vZNX MyMath
// (c) 2006, Ryu Fukushima
package my.chap6.failtest;

import junit.framework.TestCase;

public class MyMathTest extends TestCase {
    public MyMathTest(String fName) {
        super(fName);
    }

    // abs() ̃eXg
    public void testAbsForEqual() {
        MyMath m = new MyMath();
        int result = m.abs(-5);
        int expected = 5;

        assertEquals("vZʂAΒlɂȂĂ܂B", expected, result);
    }

    public void testAbsForFail() {
        MyMath m = new MyMath();
        int result = m.abs(-5);

        if (result < 0) {
            fail("vZʂAΒlɂȂĂ܂B");
        }
    }

    public void testAbsForAssertTrue() {
        MyMath m = new MyMath();
        int result = m.abs(-5);

        assertTrue("vZʂA}CiXɂȂĂ܂B", result >= 0);
    }

    public void testAbsForAssertFalse() {
        MyMath m = new MyMath();
        int result = m.abs(-5);

        assertFalse("vZʂA0ȏɂȂĂ܂B", result < 0);
    }

    // getRandom() ̃eXg (K 2̉񓚗)
    public void testGetRandomForFail() {
        MyMath m = new MyMath();
        int result = 0;

        for (int i = 0; i < 1000; i++) {
            result = m.getRandom(100);
            if (result < 0 || 100 < result) {
                fail("ʂA\l͈̔͂ɓĂ܂B");
            }
        }
    }

    public void testGetRandomForAssertTrue() {
        MyMath m = new MyMath();
        int result = 0;

        for (int i = 0; i < 1000; i++) {
            result = m.getRandom(100);
            assertTrue("ʂA}CiXɂȂĂ܂B", 0 <= result);
            assertTrue("ʂA100傫ȂĂ܂B", result <= 100);
        }
    }

    public void testGetRandomForAssertFalse() {
        MyMath m = new MyMath();
        int result = 0;

        for (int i = 0; i < 1000; i++) {
            result = m.getRandom(100);
            assertFalse("ʂA}CiXɂȂĂ܂B", result < 0);
            assertFalse("ʂA100傫ȂĂ܂B", 100 < result);
        }
    }
}
// end of MathTest.java
