package my.mystore.business;

import junit.framework.TestCase;

public class BillCalculatorStep2BadTest extends TestCase {

    // ̏ꍇ: n P[X04  P[X14
    // 1 false false 0
    // 500 false false 0
    // 999 false false 0
    // 1000 false false 2%
    // 1001 false false 2%
    // 50000 false false 2%
    // 99999 false false 2%
    // 100000 false false 5%
    // 100001 false false 5%
    // 2999999 false false 5%
    // 3000000 false false 5%
    public void testGetDiscountRateMember() {
        BillCalculator billcalc = new BillCalculator();
        double actual = 0;

        actual = billcalc.getDiscountRate(1, false, false);
        assertEquals("eXgP[X 04", 0, actual, 0.001);

        actual = billcalc.getDiscountRate(500, false, false);
        assertEquals("eXgP[X 05", 0, actual, 0.001);

        actual = billcalc.getDiscountRate(999, false, false);
        assertEquals("eXgP[X 06", 0, actual, 0.001);

        actual = billcalc.getDiscountRate(1000, false, false);
        assertEquals("eXgP[X 07", 0.02, actual, 0.001);

        actual = billcalc.getDiscountRate(1001, false, false);
        assertEquals("eXgP[X 08", 0.02, actual, 0.001);

        actual = billcalc.getDiscountRate(50000, false, false);
        assertEquals("eXgP[X 09", 0.02, actual, 0.001);

        actual = billcalc.getDiscountRate(99999, false, false);
        assertEquals("eXgP[X 10", 0.02, actual, 0.001);

        actual = billcalc.getDiscountRate(100000, false, false);
        assertEquals("eXgP[X 11", 0.05, actual, 0.001);

        actual = billcalc.getDiscountRate(100001, false, false);
        assertEquals("eXgP[X 12", 0.05, actual, 0.001);

        actual = billcalc.getDiscountRate(2999999, false, false);
        assertEquals("eXgP[X 13", 0.05, actual, 0.001);

        actual = billcalc.getDiscountRate(3000000, false, false);
        assertEquals("eXgP[X 14", 0.05, actual, 0.001);
    }

    // ̏ꍇ: ُn P[X01  P[X03AP[X15AP[X16
    // 悭ȂeXg\bh̗
    // eXgɐƂȍ~eXgȂȂ
    public void testGetDiscountRateNotMemberError() {
        BillCalculator billcalc = new BillCalculator();
        try {
            billcalc.getDiscountRate(-1000, false, false);
            fail("(-1000)̃`FbNɖ肪܂B");
            billcalc.getDiscountRate(-1000, false, false);
            fail("(-1000)̃`FbNɖ肪܂B");
            billcalc.getDiscountRate(-1, false, false);
            fail("(-1)̃`FbNɖ肪܂B");
            billcalc.getDiscountRate(0, false, false);
            fail("(0)̃`FbNɖ肪܂B");
            billcalc.getDiscountRate(10000, false, false);
            fail("̃`FbNɖ肪܂B");
            billcalc.getDiscountRate(3000001, false, false);
            fail("(3000001)̃`FbNɖ肪܂B");
            billcalc.getDiscountRate(5000000, false, false);
            fail("(5000000)̃`FbNɖ肪܂B");
        } catch (IllegalArgumentException e) {
            assertTrue("̃`FbN̓pX܂B", true);
        }
    }

    // v 1000
    // Ly[ false
    // / true
    // ҂錋 l 2%

    public void testGetDiscountRateCase07() {
        BillCalculator billcalc = new BillCalculator();
        double actual = billcalc.getDiscountRate(1000, false, true);
        double expected = 0.05;

        assertEquals("eXgP[X 07", expected, actual, 0.001);
    }

    // v 3000000
    // Ly[ true
    // / false
    // ҂錋 l 5%

    public void testGetDiscountRateCase45() {
        BillCalculator billcalc = new BillCalculator();
        double actual = billcalc.getDiscountRate(3000000, true, false);
        double expected = 0.15;

        assertEquals("eXgP[X 45", expected, actual, 0.001);
    }
}
